#include "declarations.h"
#include "time.h"

void insert_gpl_notice(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;

   gchar gpl_notice[] = {
   "/*\n"
   " *  This program is free software; you can redistribute it and/or modify\n"
   " *  it under the terms of the GNU General Public License as published by\n"
   " *  the Free Software Foundation; either version 2 of the License, or\n"
   " *  (at your option) any later version.\n"
   " *\n"
   " *  This program is distributed in the hope that it will be useful,\n"
   " *  but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
   " *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
   " *  GNU Library General Public License for more details.\n"
   " *\n"
   " *  You should have received a copy of the GNU Library General Public License\n"
   " *  along with this program; if not, write to the Free Software\n"
   " *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n"
   " */\n"
   };

   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, gpl_notice, strlen(gpl_notice), (gint *)&editable->current_pos);
}

void insert_changelog_string(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   insert_date_time(widget, data);
   gtk_editable_insert_text(editable, " ", 1, (gint *)&editable->current_pos);
   insert_name(widget, data);
   gtk_editable_insert_text(editable, " <", 2, (gint *)&editable->current_pos);
   insert_email(widget, data);
   gtk_editable_insert_text(editable, ">", 1, (gint *)&editable->current_pos);
}

void insert_comment(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "/*\n *\n */", 9, (gint *)&editable->current_pos);
}

void insert_date_time(GtkWidget *widget, gpointer data)
{
   char buffer[128];
   time_t cur_time;
   struct tm *time_ptr;
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   time(&cur_time);
   time_ptr = localtime(&cur_time);
   strftime(buffer, sizeof(buffer), "%a %b %d %X %Z %Y", time_ptr);
   gtk_editable_insert_text(editable, buffer, strlen(buffer), (gint *)&editable->current_pos);
}

void insert_username(GtkWidget *widget, gpointer data)
{
   gchar *text;
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   text = g_new(char, strlen(getenv("USER"))+1);
   strcpy(text, getenv("USER"));
   gtk_editable_insert_text(editable, text, strlen(text), (gint *)&editable->current_pos);
}

void insert_name(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, general_preferences.name, strlen(general_preferences.name), (gint *)&editable->current_pos);
}

void insert_email(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, general_preferences.email, strlen(general_preferences.email), (gint *)&editable->current_pos);
}
