#include "declarations.h"

void gds_file_ask_focus(GtkWidget *widget, GdsFile *gds_file);

GdsFile *create_file(gchar *name)
{
   GdsFile *new_file;
   GtkWidget *label;
   gchar cwd[256];
   gchar *path;
   gchar *file;
   gchar *full;

   getcwd(cwd, 256);
   path = get_path_from_filename(name);
   file = get_file_from_filename(name);
   if(!path) full = g_strconcat(cwd, "/", file, NULL);
   else full = g_strconcat(path, "/", file, NULL);
   new_file = (GdsFile *)gds_file_new(full);
   g_free(path);
   g_free(full);
   gtk_signal_connect(GTK_OBJECT(new_file->tear_away), "window_focused", GTK_SIGNAL_FUNC(gds_file_ask_focus), new_file);
   gtk_signal_connect(GTK_OBJECT(new_file->tear_away), "attached", GTK_SIGNAL_FUNC(file_change), new_file);
   gtk_signal_connect(GTK_OBJECT(new_file->text), "move_to_row", GTK_SIGNAL_FUNC(file_pos_changed), 0);
   gtk_signal_connect(GTK_OBJECT(new_file->text), "move_to_column", GTK_SIGNAL_FUNC(file_pos_changed), 0);
   gtk_widget_show(GTK_WIDGET(new_file));
   files_list = g_list_append(files_list, (gpointer)new_file);

   label = gtk_label_new(file);
   gtk_widget_show(label);
   gtk_notebook_append_page(GTK_NOTEBOOK(files_book), new_file->tear_away, label);
   gtk_signal_connect(GTK_OBJECT(new_file->menu_item), "activate", GTK_SIGNAL_FUNC(file_change), new_file);
   gtk_menu_append(GTK_MENU(windowmenu), new_file->menu_item);
   cur_page = total_files;
   total_files++;
   gtk_notebook_set_page(GTK_NOTEBOOK(files_book), cur_page);
   set_notebook_page(GTK_NOTEBOOK(files_book), NULL, cur_page, (GdsFile *)g_list_nth_data(files_list, cur_page));
   gtk_widget_set_style(new_file->text, extext_style);
   gds_editor_set_bgcolor(GDS_EDITOR(new_file->text), &extext_style->bg[GTK_STATE_NORMAL]);
   if(general_preferences.font)
      gdk_font_ref(general_preferences.font);
   new_file->props.auto_indent = general_preferences.auto_indent;
   new_file->props.use_spaces = general_preferences.use_spaces;
   new_file->props.spaces = general_preferences.spaces;
   GTK_EXTEXT(new_file->text)->default_tab_width = general_preferences.spaces;
   g_free(file);
   return(new_file);
}

void gds_file_ask_focus(GtkWidget *widget, GdsFile *gds_file)
{
   file_change(widget, gds_file);
}

