#include "declarations.h"
#include "xpm/selection.xpm"
#include "xpm/select_all.xpm"
#include "xpm/comment.xpm"
#include "xpm/dotslash.xpm"
#include "xpm/debug.xpm"
#include "xpm/window.xpm"
#include "xpm/arrow.xpm"
#include "xpm/gnu_gpl.xpm"

GtkWidget *filemenu;
GtkWidget *recentmenu;
GtkWidget *editmenu;
GtkWidget *searchmenu;
GtkWidget *buildmenu;
GtkWidget *insertmenu;
GtkWidget *settingsmenu;
GtkWidget *windowmenu;
GtkWidget *sessionmenu;
GtkWidget *helpmenu;
GtkWidget *file_menu_new;
GtkWidget *file_menu_open;
GtkWidget *file_menu_revert;
GtkWidget *file_menu_save;
GtkWidget *file_menu_saveas;
GtkWidget *file_menu_save_all;
GtkWidget *file_menu_close;
GtkWidget *file_menu_close_all;
GtkWidget *edit_popup_menu;

GnomeUIInfo recent_menu[] = {
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_END
};

GnomeUIInfo file_menu[] = {
   GNOMEUIINFO_MENU_NEW_ITEM(_("_New File"), _("New source file"), new_file, 0),
   GNOMEUIINFO_MENU_OPEN_ITEM(open_file, 0),
   GNOMEUIINFO_MENU_REVERT_ITEM(revert_current_file, 0),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_SAVE_ITEM(save_file, 0),
   GNOMEUIINFO_MENU_SAVE_AS_ITEM(save_file_as, 0),
   GNOME_APP_UI_ITEM, _("Sa_ve All"), _("Save all open files"), save_all_files, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE, GDK_F10, (GdkModifierType) 0, 0,
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_CLOSE_ITEM(close_file, 0),
   GNOME_APP_UI_ITEM, _("C_lose All"), _("Close all open files"), close_all_files, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLOSE, GDK_F11, (GdkModifierType) 0, 0,
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_SUBTREE(_("Recent Files"), recent_menu),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_EXIT_ITEM(pre_exit, 0),
   GNOMEUIINFO_END
};

GnomeUIInfo edit_menu[] = {
   GNOMEUIINFO_MENU_UNDO_ITEM(undo_last, 0),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_CUT_ITEM(cut_text, 0),
   GNOMEUIINFO_MENU_COPY_ITEM(copy_text, 0),
   GNOMEUIINFO_MENU_PASTE_ITEM(paste_text, 0),
   GNOMEUIINFO_SEPARATOR,
   GNOME_APP_UI_ITEM, _("C_lear"), _("Clear selection"), clear_text, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR, GDK_F8, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("Clear _Entry"), _("Clear the command entry"), clear_entry, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR, GDK_F8, GDK_SHIFT_MASK, 0,
   GNOMEUIINFO_SEPARATOR,
   GNOME_APP_UI_ITEM, _("Co_mment Selection"), _("Comment out the current selection"), comment_selection, 0, 0, GNOME_APP_PIXMAP_DATA, comment_xpm, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("_Select Current"), _("Select the current word"), select_current, 0, 0, GNOME_APP_PIXMAP_DATA, selection_xpm, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("Select _All"), _("Select the entire document"), select_all_text, 0, 0, GNOME_APP_PIXMAP_DATA, select_all_xpm, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("Selection > Command"), _("Copy the current selection to the command entry"), copy_selection_to_command_entry, 0, 0, GNOME_APP_PIXMAP_DATA, arrow_xpm, 0, (GdkModifierType) 0, 0,
   GNOMEUIINFO_SEPARATOR,
   GNOME_APP_UI_ITEM, _("Re-Highlight"), _("Re-Highlight the current file"), highlight_syntax, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CONVERT, GDK_F4, (GdkModifierType) 0, 0,
   GNOMEUIINFO_SEPARATOR,
   GNOME_APP_UI_ITEM, _("P_roperties"), _("Edit properties"), edit_properties, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PROPERTIES, 0, (GdkModifierType) 0, 0,
   GNOMEUIINFO_END
};

GnomeUIInfo search_menu[] = {
   GNOMEUIINFO_MENU_FIND_ITEM(do_find, 0),
   GNOMEUIINFO_MENU_REPLACE_ITEM(do_replace, 0),
   GNOME_APP_UI_ITEM, _("Goto Line"), _("Goto a line"), do_gotoline, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_JUMP_TO, 'L', GDK_CONTROL_MASK, 0,
   GNOME_APP_UI_ITEM, _("Search Manpages"), _("Search manpages"), do_manpage, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_INDEX, GDK_F1, (GdkModifierType) 0, 0,
   GNOMEUIINFO_END
};

GnomeUIInfo build_menu[] = {
   GNOME_APP_UI_ITEM, _("_Compile"), _("Compile the current source file"), compile_file, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_EXEC, GDK_F5, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("_Debug"), _("Debug the current source file"), debug_file, 0, 0, GNOME_APP_PIXMAP_DATA, debug_xpm, GDK_F5, GDK_CONTROL_MASK, 0,
   GNOME_APP_UI_ITEM, _("_Execute"), _("Execute the current program"), execute_file, 0, 0, GNOME_APP_PIXMAP_DATA, dotslash_xpm, GDK_F5, GDK_SHIFT_MASK, 0,
   GNOME_APP_UI_ITEM, _("Clear _Window"), _("Clear the compiler output window"), clear_list, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR, 0, (GdkModifierType) 0, 0,
   GNOMEUIINFO_END
};

GnomeUIInfo insert_menu[] = {
   GNOMEUIINFO_ITEM_NONE(_("_GPL Notice"), _("Insert GPL notice"), insert_gpl_notice),         
   GNOMEUIINFO_ITEM_NONE(_("ChangeLog _Entry"), _("Insert ChangeLog entry"), insert_changelog_string),         
   GNOMEUIINFO_ITEM_NONE(_("_Comment"), _("Insert C style comment"), insert_comment),         
   GNOMEUIINFO_ITEM_NONE(_("_Date & Time"), _("Insert current date and time"), insert_date_time),         
   GNOMEUIINFO_ITEM_NONE(_("_User Name"), _("Insert the name of the current user"), insert_username),         
   GNOMEUIINFO_ITEM_NONE(_("_Name"), _("Insert name (from prefs)"), insert_name),         
   GNOMEUIINFO_ITEM_NONE(_("Email _Address"), _("Insert email (from prefs)"), insert_email),         
   GNOMEUIINFO_END
};

GnomeUIInfo settings_menu[] = {
   GNOMEUIINFO_MENU_PREFERENCES_ITEM(edit_preferences, 0),
   GNOMEUIINFO_END
};

GnomeUIInfo window_menu[] = {
   GNOME_APP_UI_ITEM, _("_New Top-Level Window"), _("New instance of CodeCommander"), new_window, 0, 0, GNOME_APP_PIXMAP_DATA, window_xpm, 0, (GdkModifierType) 0, 0,
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_END
};

GnomeUIInfo session_menu[] = {
   GNOME_APP_UI_ITEM, _("_Save Current Session"), _("Save the current session"), save_session_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("_Open Session"), _("Open a session"), open_session_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_OPEN, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("Save Session _As"), _("Save the current session with a different name"), save_session_as, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE_AS, 0, (GdkModifierType) 0, 0,
   GNOMEUIINFO_END
};

GnomeUIInfo help_menu[] = {
   GNOMEUIINFO_SEPARATOR,
   GNOME_APP_UI_ITEM, _("_README"), _("View README file"), do_contents, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_INDEX, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("_License"), _("View License agreement"), do_license, 0, 0, GNOME_APP_PIXMAP_DATA, gnu_gpl_xpm, 0, (GdkModifierType) 0, 0,
   GNOME_APP_UI_ITEM, _("Language _Definitions"), _("Informaton on CodeCommander Language Definitions"), do_langs, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ATTACH, 0, (GdkModifierType) 0, 0,
   GNOMEUIINFO_MENU_ABOUT_ITEM(do_about, 0),
   GNOMEUIINFO_END
};

GnomeUIInfo menubar[] = {
   GNOMEUIINFO_SUBTREE(_("_File"), file_menu),
   GNOMEUIINFO_SUBTREE(_("_Edit"), edit_menu),
   GNOMEUIINFO_SUBTREE(_("_Search"), search_menu),
   GNOMEUIINFO_SUBTREE(_("_Build"), build_menu),
   GNOMEUIINFO_SUBTREE(_("_Insert"), insert_menu),
   GNOMEUIINFO_SUBTREE(_("Se_ttings"), settings_menu),
   GNOMEUIINFO_SUBTREE(_("_Windows"), window_menu),
   GNOMEUIINFO_SUBTREE(_("Sessio_n"), session_menu),
   GNOMEUIINFO_SUBTREE(_("_Help"), help_menu),
   GNOMEUIINFO_END
};

static GtkItemFactoryEntry popup_items[] = {
   { _("/_File"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/File/_Save"), NULL, GTK_SIGNAL_FUNC(save_file), 0, NULL },
   { _("/File/Save _As"), NULL, GTK_SIGNAL_FUNC(save_file_as), 0, NULL },
   { _("/File/_Close"), NULL, GTK_SIGNAL_FUNC(close_file), 0, NULL },
   { _("/File/sep1"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/File/Save Current Session"), NULL, GTK_SIGNAL_FUNC(save_session_cb), 0, NULL },	 
   { _("/_Edit"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Edit/_Undo"), NULL, GTK_SIGNAL_FUNC(undo_last), 0, NULL },
   { _("/Edit/sep1"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/_Cut"), NULL, GTK_SIGNAL_FUNC(cut_text), 0, NULL },
   { _("/Edit/C_opy"), NULL, GTK_SIGNAL_FUNC(copy_text), 0, NULL },
   { _("/Edit/_Paste"), NULL, GTK_SIGNAL_FUNC(paste_text), 0, NULL },
   { _("/Edit/sep2"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/C_lear"), NULL, GTK_SIGNAL_FUNC(clear_text), 0, NULL },
   { _("/Edit/Clear _Entry"), NULL, GTK_SIGNAL_FUNC(clear_entry), 0, NULL },
   { _("/Edit/sep3"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/Comment _Selection"), NULL, GTK_SIGNAL_FUNC(comment_selection), 0, NULL },
   { _("/Edit/Select Current"), NULL, GTK_SIGNAL_FUNC(select_current), 0, NULL },
   { _("/Edit/Select _All"), NULL, GTK_SIGNAL_FUNC(select_all_text), 0, NULL },
   { _("/Edit/Selection > Command"), NULL, GTK_SIGNAL_FUNC(copy_selection_to_command_entry), 0, NULL },
   { _("/Edit/sep4"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/Re-Highlight"), NULL, GTK_SIGNAL_FUNC(highlight_syntax), 0, NULL },
   { _("/Edit/sep5"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/P_roperties"), NULL, GTK_SIGNAL_FUNC(edit_properties), 0, NULL },
   { _("/_Search"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Search/_Find"), NULL, GTK_SIGNAL_FUNC(do_find), 0, NULL },
   { _("/Search/_Replace"), NULL, GTK_SIGNAL_FUNC(do_replace), 0, NULL },
   { _("/Search/_Goto Line"), NULL, GTK_SIGNAL_FUNC(do_gotoline), 0, NULL },
   { _("/Search/_Search Manpages"), NULL, GTK_SIGNAL_FUNC(do_manpage), 0, NULL },
   { _("/_Build"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Build/_Compile"), NULL, GTK_SIGNAL_FUNC(compile_file), 0, NULL },
   { _("/Build/_Debug"), NULL, GTK_SIGNAL_FUNC(debug_file), 0, NULL },
   { _("/Build/_Execute"), NULL, GTK_SIGNAL_FUNC(execute_file), 0, NULL },
   { _("/Build/Clear Window"), NULL, GTK_SIGNAL_FUNC(clear_list), 0, NULL },
   { _("/_Insert"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Insert/_GPL Notice"), NULL, GTK_SIGNAL_FUNC(insert_gpl_notice), 0, NULL },
   { _("/Insert/ChangeLog _Entry"), NULL, GTK_SIGNAL_FUNC(insert_changelog_string), 0, NULL },
   { _("/Insert/_Comment"), NULL, GTK_SIGNAL_FUNC(insert_comment), 0, NULL },
   { _("/Insert/_Date & Time"), NULL, GTK_SIGNAL_FUNC(insert_date_time), 0, NULL },
   { _("/Insert/_User Name"), NULL, GTK_SIGNAL_FUNC(insert_username), 0, NULL },
   { _("/Insert/_Name"), NULL, GTK_SIGNAL_FUNC(insert_name), 0, NULL },
   { _("/Insert/Email _Address"), NULL, GTK_SIGNAL_FUNC(insert_email), 0, NULL },
};

void make_menus()
{
   GtkItemFactory *item_factory;
   GtkWidget *menu_bar;
   gint nmenu_items;

   gnome_app_create_menus(GNOME_APP(window), menubar);
   gnome_app_install_appbar_menu_hints(GNOME_APPBAR(appbar), menubar);

   filemenu = menubar[0].widget;
   recentmenu = recent_menu[0].widget->parent;
   editmenu = menubar[1].widget;
   searchmenu = menubar[2].widget;
   buildmenu = menubar[3].widget;
   insertmenu = menubar[4].widget;
   settingsmenu = menubar[5].widget;
   windowmenu = window_menu[0].widget->parent;
   sessionmenu = menubar[7].widget;
   helpmenu = menubar[8].widget;

   file_menu_new = file_menu[0].widget;
   file_menu_open = file_menu[1].widget;
   file_menu_revert = file_menu[2].widget;
   file_menu_save = file_menu[4].widget;
   file_menu_saveas = file_menu[5].widget;
   file_menu_save_all = file_menu[6].widget;
   file_menu_close = file_menu[8].widget;
   file_menu_close_all = file_menu[9].widget;
   
   nmenu_items = sizeof(popup_items) / sizeof(popup_items[0]);
   item_factory = gtk_item_factory_new(GTK_TYPE_MENU, "<edit popup>", 0);
   gtk_item_factory_create_items(item_factory, nmenu_items, popup_items, 0);

   edit_popup_menu = gtk_item_factory_get_widget(item_factory, "<edit popup>");
   gtk_widget_show(edit_popup_menu);
}


