#include "declarations.h"

void do_contents(GtkWidget *widget, gpointer data)
{
   gchar readme[] = PREFIX "/share/" PACKAGE "/docs/README";
   make_file_reader(readme);
}

void do_license(GtkWidget *widget, gpointer data)
{
   gchar copying[] = PREFIX "/share/" PACKAGE "/docs/COPYING";
   make_file_reader(copying);
}

void do_langs(GtkWidget *widget, gpointer data)
{
   gchar langs[] = PREFIX "/share/" PACKAGE "/docs/LanguageDefinitions";
   make_file_reader(langs);
}

void make_file_reader(gchar *filename)
{
   GtkWidget *text_window;
   GtkWidget *main_box;
   GtkWidget *text_box;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *buttons_box;
   GtkWidget *close_button;
   GtkWidget *hsep;   

   text_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(text_window), 10);   
   gtk_window_set_title(GTK_WINDOW(text_window), filename);

   main_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(text_window), main_box);
   gtk_widget_show(main_box);   

   text_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_box), text_box, TRUE, TRUE, 0);
   gtk_widget_show(text_box);
   
   text = gtk_text_new(0, 0);
   gtk_widget_set_usize(text, 600, 400);
   gtk_box_pack_start(GTK_BOX(text_box), text, TRUE, TRUE, 0);
   gtk_widget_show(text);

   scroller = gtk_vscrollbar_new(GTK_ADJUSTMENT(GTK_TEXT(text)->vadj));
   gtk_box_pack_start(GTK_BOX(text_box), scroller, FALSE, FALSE, 0);
   gtk_widget_show(scroller);
   
   hsep = gtk_hseparator_new();
   gtk_box_pack_start(GTK_BOX(main_box), hsep, FALSE, TRUE, 15);
   gtk_widget_show(hsep);
   
   buttons_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);
   close_button = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_box_pack_end(GTK_BOX(buttons_box), close_button, FALSE, FALSE, 15);   
   gtk_signal_connect(GTK_OBJECT(close_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(text_window));
   GTK_WIDGET_SET_FLAGS(close_button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default(close_button);
   gtk_widget_show(close_button);

   gtk_widget_show(text_window);
   write_file_to_gtktext(filename, text, 0);
}

void write_file_to_gtktext(gchar *filename, GtkWidget *text, GdkColor *color)
{
   FILE *file;
   gchar buffer[256];

   if(!(file = fopen(filename, "r")))
   {
      g_print("%s does not exist.\n", filename);
      return;
   }
   gtk_text_freeze(GTK_TEXT(text));
   while(fgets(buffer, sizeof(buffer), file) != NULL)
   {
      gtk_text_insert(GTK_TEXT(text), 0, color, 0, buffer, -1);
   }
   gtk_text_thaw(GTK_TEXT(text));
   fclose(file);
   return;
}