#include "declarations.h"

gint get_which_radio_active(GSList *list);
void set_which_radio_active(GSList *list, gint which);

Preferences general_preferences;
Preferences backup_preferences;
Preferences default_preferences;

// The main window
GtkWidget *settings_window;

// General Settings
GtkWidget *default_dir_entry = NULL;
GtkWidget *projects_dir_entry = NULL;
GtkWidget *save_session = NULL;
GtkWidget *open_session = NULL;
GtkWidget *hist_spin = NULL;
GtkWidget *undo_spin = NULL;

// User settings
GtkWidget *name_of_user = NULL;
GtkWidget *email_of_user = NULL;

// Colors & Fonts
GtkWidget *font = NULL;
gboolean font_changed = FALSE;
GtkWidget *fg = NULL;
gboolean fg_changed = FALSE;
GtkWidget *bg = NULL;
gboolean bg_changed = FALSE;
GtkWidget *s_fg = NULL;
gboolean s_fg_changed = FALSE;
GtkWidget *s_bg = NULL;
gboolean s_bg_changed = FALSE;

// File Settings
GtkWidget *syntax = NULL;
GtkWidget *auto_indent = NULL;
GtkWidget *use_spaces = NULL;
GtkWidget *spaces_spin = NULL;

// NoteBook Settings
GtkWidget *notebook_pos_top = NULL;
GtkWidget *notebook_pos_right = NULL;
GtkWidget *notebook_pos_bottom = NULL;
GtkWidget *notebook_pos_left = NULL;
GtkWidget *notebook_pos_none = NULL;

void edit_preferences(GtkWidget *widget, gpointer data)
{
   GtkWidget *main_box;
   GtkWidget *notebook_box;
   GtkWidget *main_book;
   GtkWidget *general_box;
   GtkWidget *general_label;
   GtkWidget *usersettings_box;
   GtkWidget *usersettings_label;
   GtkWidget *notebooksettings_box;
   GtkWidget *notebooksettings_label;
   GtkWidget *colorsnfonts_box;
   GtkWidget *colorsnfonts_label;
   GtkWidget *filesettings_box;
   GtkWidget *filesettings_label;

   GtkWidget *gen_box;
   GtkWidget *gen_frame;
   GtkWidget *dir_frame;
   GtkWidget *dir_box;
   GtkWidget *history_frame;
   GtkWidget *history_box;

   GtkWidget *user_box;
   GtkWidget *user_frame;

   GtkWidget *notebooktabs_frame;
   GtkWidget *notebooktabs_box;
   
   GtkWidget *cnf_box;
   GtkWidget *cnf_frame;
   GtkWidget *font_frame;
   GtkWidget *font_box;
   GtkWidget *color_frame;
   GtkWidget *color_box;

   GtkWidget *syntax_frame;
   GtkWidget *syntax_box;
   GtkWidget *tabs_frame;
   GtkWidget *tabs_box;
  
   GtkWidget *util_box;
   GtkWidget *util_label;

   GtkWidget *buttons_box;
   GtkWidget *ok_button;
   GtkWidget *apply_button;
   GtkWidget *defaults_button;
   GtkWidget *undo_button;
   GtkWidget *cancel_button;

   if(settings_window && GTK_IS_WIDGET(settings_window))
   {
      gdk_window_raise(settings_window->window);
      gtk_widget_grab_focus(settings_window);
      return;
   }

   copy_preferences(&general_preferences, &backup_preferences); //save the current preferences

   font_changed = FALSE;   
   fg_changed = FALSE;
   bg_changed = FALSE;
   s_fg_changed = FALSE;
   s_bg_changed = FALSE;

   settings_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(settings_window), 10);   
   gtk_window_set_title(GTK_WINDOW(settings_window), _("Edit " PACKAGE " Preferences"));
   
   main_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(settings_window), main_box);
   gtk_widget_show(main_box);

   notebook_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(main_box), notebook_box, TRUE, TRUE, 0);
   gtk_widget_show(notebook_box);
   main_book = gtk_notebook_new ();
   gtk_notebook_set_tab_pos(GTK_NOTEBOOK(main_book), GTK_POS_TOP);
   gtk_box_pack_start(GTK_BOX(notebook_box), main_book, TRUE, TRUE, 0);
   gtk_widget_show(main_book);
   
   general_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(general_box), 10);
   gtk_widget_show(general_box);
   general_label = gtk_label_new(_("General"));
   gtk_widget_show(general_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), general_box, general_label);

   gen_frame = gtk_frame_new(_("General Settings"));
   gtk_box_pack_start(GTK_BOX(general_box), gen_frame, TRUE, TRUE, 0);
   gtk_widget_show(gen_frame);

   gen_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(gen_box), 10);
   gtk_container_add(GTK_CONTAINER(gen_frame), gen_box);   
   gtk_widget_show(gen_box);

   dir_frame = gtk_frame_new(_("Directory Settings"));
   gtk_box_pack_start(GTK_BOX(gen_box), dir_frame, FALSE, FALSE, 0);
   gtk_widget_show(dir_frame);

   dir_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(dir_box), 10);
   gtk_container_add(GTK_CONTAINER(dir_frame), dir_box);   
   gtk_widget_show(dir_box);

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(dir_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Default Directory:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);   
   default_dir_entry = gnome_direntry_new();
   gtk_box_pack_start(GTK_BOX(util_box), default_dir_entry, TRUE, TRUE, 0);   
   gtk_widget_show(default_dir_entry);   

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(dir_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Projects Directory:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);   
   projects_dir_entry = gnome_direntry_new();
   gtk_box_pack_start(GTK_BOX(util_box), projects_dir_entry, TRUE, TRUE, 0);   
   gtk_widget_show(projects_dir_entry);   

   /* Start of spinbutton for history stuff */
   history_frame = gtk_frame_new(_("History Settings"));
   gtk_box_pack_start(GTK_BOX(gen_box), history_frame, FALSE, FALSE, 0);
   gtk_widget_show(history_frame);

   history_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(history_box), 10);
   gtk_container_add(GTK_CONTAINER(history_frame), history_box);   
   gtk_widget_show(history_box);

   save_session = make_button(_("Save session on exit?"), history_box, &general_preferences.save_session);
   open_session = make_button(_("Open last session on startup?"), history_box, &general_preferences.open_session);

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(history_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Items to show in history lists:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);

   hist_spin = gtk_spin_button_new(GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 25, 1, 10, 0)), 1, 0);
   gtk_box_pack_start(GTK_BOX(util_box), hist_spin, TRUE, TRUE, 0);   
   gtk_widget_show(hist_spin);
   /* End of spinbutton for history stuff */

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(history_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Maximum Undo saves:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);

   undo_spin = gtk_spin_button_new(GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 100, 1, 10, 0)), 1, 0);
   gtk_box_pack_start(GTK_BOX(util_box), undo_spin, TRUE, TRUE, 0);   
   gtk_widget_show(undo_spin);
   /* End of General notebook tab */

   /* Start of User Settings tab */
   
   usersettings_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(usersettings_box), 5);
   gtk_widget_show(usersettings_box);
   usersettings_label = gtk_label_new(_("User Settings"));
   gtk_widget_show(usersettings_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), usersettings_box, usersettings_label);

   user_frame = gtk_frame_new(_("User Information"));
   gtk_box_pack_start(GTK_BOX(usersettings_box), user_frame, TRUE, TRUE, 0);
   gtk_widget_show(user_frame);

   user_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(user_box), 5);
   gtk_container_add(GTK_CONTAINER(user_frame), user_box);   
   gtk_widget_show(user_box);

   util_box = gtk_hbox_new(FALSE, 5);
   gtk_box_pack_start(GTK_BOX(user_box), util_box, TRUE, TRUE, 5);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Name of user:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);   
   name_of_user = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(util_box), name_of_user, TRUE, TRUE, 0);   
   gtk_widget_show(name_of_user);

   util_box = gtk_hbox_new(FALSE, 5);
   gtk_box_pack_start(GTK_BOX(user_box), util_box, TRUE, TRUE, 5);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Email of user:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);   
   email_of_user = gtk_entry_new();
   gtk_box_pack_start(GTK_BOX(util_box), email_of_user, TRUE, TRUE, 0);   
   gtk_widget_show(email_of_user);

   /* End of user settings */

   /* Start of notebook settings */

   notebooksettings_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(notebooksettings_box), 5);
   gtk_widget_show(notebooksettings_box);
   notebooksettings_label = gtk_label_new(_("Notebook Settings"));
   gtk_widget_show(notebooksettings_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), notebooksettings_box, notebooksettings_label);

   notebooktabs_frame = gtk_frame_new(_("Tab Position"));
   gtk_box_pack_start(GTK_BOX(notebooksettings_box), notebooktabs_frame, TRUE, TRUE, 0);
   gtk_widget_show(notebooktabs_frame);

   notebooktabs_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(notebooktabs_box), 5);
   gtk_container_add(GTK_CONTAINER(notebooktabs_frame), notebooktabs_box);   
   gtk_widget_show(notebooktabs_box);

   util_box = gtk_vbox_new(FALSE, 5);
   gtk_box_pack_start(GTK_BOX(notebooktabs_box), util_box, TRUE, TRUE, 5);
   gtk_widget_show(util_box);
   
   notebook_pos_left = gtk_radio_button_new_with_label(NULL, "Left");
   gtk_box_pack_start(GTK_BOX(util_box), notebook_pos_left, FALSE, FALSE, 10);
   gtk_widget_show(notebook_pos_left);
   notebook_pos_right = gtk_radio_button_new_with_label(GTK_RADIO_BUTTON(notebook_pos_left)->group, "Right");
   gtk_box_pack_start(GTK_BOX(util_box), notebook_pos_right, FALSE, FALSE, 10);
   gtk_widget_show(notebook_pos_right);
   notebook_pos_top = gtk_radio_button_new_with_label(GTK_RADIO_BUTTON(notebook_pos_left)->group, "Top");
   gtk_box_pack_start(GTK_BOX(util_box), notebook_pos_top, FALSE, FALSE, 10);
   gtk_widget_show(notebook_pos_top);
   notebook_pos_bottom = gtk_radio_button_new_with_label(GTK_RADIO_BUTTON(notebook_pos_left)->group, "Bottom");
   gtk_box_pack_start(GTK_BOX(util_box), notebook_pos_bottom, FALSE, FALSE, 10);
   gtk_widget_show(notebook_pos_bottom);
   notebook_pos_none = gtk_radio_button_new_with_label(GTK_RADIO_BUTTON(notebook_pos_left)->group, "No Tabs");
   gtk_box_pack_start(GTK_BOX(util_box), notebook_pos_none, FALSE, FALSE, 10);
   gtk_widget_show(notebook_pos_none);

   /* start of colors and fonts stuff */
   colorsnfonts_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(colorsnfonts_box), 10);
   gtk_widget_show(colorsnfonts_box);
   colorsnfonts_label = gtk_label_new(_("Colors and Fonts"));
   gtk_widget_show(colorsnfonts_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), colorsnfonts_box, colorsnfonts_label);

   cnf_frame = gtk_frame_new(_("GtkExText Settings"));
   gtk_box_pack_start(GTK_BOX(colorsnfonts_box), cnf_frame, TRUE, TRUE, 0);
   gtk_widget_show(cnf_frame);

   cnf_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(cnf_box), 10);
   gtk_container_add(GTK_CONTAINER(cnf_frame), cnf_box);   
   gtk_widget_show(cnf_box);

   font_frame = gtk_frame_new(_("Font Settings"));
   gtk_box_pack_start(GTK_BOX(cnf_box), font_frame, TRUE, TRUE, 0);
   gtk_widget_show(font_frame);

   font_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(font_box), 10);
   gtk_container_add(GTK_CONTAINER(font_frame), font_box);   
   gtk_widget_show(font_box);
   
   font = gnome_font_picker_new();
   gtk_signal_connect(GTK_OBJECT(font), "font_set", GTK_SIGNAL_FUNC(set_font_changed), 0);
   gnome_font_picker_set_mode(GNOME_FONT_PICKER(font), GNOME_FONT_PICKER_MODE_FONT_INFO);
   gnome_font_picker_set_preview_text(GNOME_FONT_PICKER(font), PACKAGE " v" VERSION);
   gnome_font_picker_fi_set_use_font_in_label(GNOME_FONT_PICKER(font), TRUE, 14);
   gnome_font_picker_set_title(GNOME_FONT_PICKER(font), _("GtkExText Font Selection..."));
   gtk_box_pack_start(GTK_BOX(font_box), font, FALSE, FALSE, 10);
   gtk_widget_show(font);
   
   color_frame = gtk_frame_new(_("Color Settings"));
   gtk_box_pack_start(GTK_BOX(cnf_box), color_frame, FALSE, FALSE, 0);
   gtk_widget_show(color_frame);

   color_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(color_box), 10);
   gtk_container_add(GTK_CONTAINER(color_frame), color_box);   
   gtk_widget_show(color_box);

   util_box  = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(color_box), util_box, FALSE, TRUE, 0);         
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Normal Text Color:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);         
   gtk_widget_show(util_label);
   fg = gnome_color_picker_new();
   gtk_signal_connect(GTK_OBJECT(fg), "color_set", GTK_SIGNAL_FUNC(set_color_changed), 0);
   gnome_color_picker_set_dither(GNOME_COLOR_PICKER(fg), FALSE);   
   gnome_color_picker_set_use_alpha(GNOME_COLOR_PICKER(fg), FALSE);   
   gtk_box_pack_end(GTK_BOX(util_box), fg, FALSE, FALSE, 0);
   gtk_widget_show(fg);

   util_box  = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(color_box), util_box, FALSE, TRUE, 0);         
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Normal Background Color:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);         
   gtk_widget_show(util_label);
   bg = gnome_color_picker_new();
   gtk_signal_connect(GTK_OBJECT(bg), "color_set", GTK_SIGNAL_FUNC(set_color_changed), 0);
   gnome_color_picker_set_dither(GNOME_COLOR_PICKER(bg), FALSE);   
   gnome_color_picker_set_use_alpha(GNOME_COLOR_PICKER(bg), FALSE);   
   gtk_box_pack_end(GTK_BOX(util_box), bg, FALSE, FALSE, 0);
   gtk_widget_show(bg);

   util_box  = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(color_box), util_box, FALSE, TRUE, 0);         
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Selected Text Color:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);         
   gtk_widget_show(util_label);
   s_fg = gnome_color_picker_new();
   gtk_signal_connect(GTK_OBJECT(s_fg), "color_set", GTK_SIGNAL_FUNC(set_color_changed), 0);
   gnome_color_picker_set_dither(GNOME_COLOR_PICKER(s_fg), FALSE);   
   gnome_color_picker_set_use_alpha(GNOME_COLOR_PICKER(s_fg), FALSE);   
   gtk_box_pack_end(GTK_BOX(util_box), s_fg, FALSE, FALSE, 0);
   gtk_widget_show(s_fg);
   
   util_box  = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(color_box), util_box, FALSE, TRUE, 0);         
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Selection Background Color:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);         
   gtk_widget_show(util_label);
   s_bg = gnome_color_picker_new();
   gtk_signal_connect(GTK_OBJECT(s_bg), "color_set", GTK_SIGNAL_FUNC(set_color_changed), 0);
   gnome_color_picker_set_dither(GNOME_COLOR_PICKER(s_bg), FALSE);   
   gnome_color_picker_set_use_alpha(GNOME_COLOR_PICKER(s_bg), FALSE);   
   gtk_box_pack_end(GTK_BOX(util_box), s_bg, FALSE, FALSE, 0);
   gtk_widget_show(s_bg);

   /* File Settings */

   filesettings_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(filesettings_box), 5);
   gtk_widget_show(filesettings_box);
   filesettings_label = gtk_label_new(_("File Settings"));
   gtk_widget_show(filesettings_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), filesettings_box, filesettings_label);

   syntax_frame = gtk_frame_new(_("Syntax Highlighting"));
   gtk_box_pack_start(GTK_BOX(filesettings_box), syntax_frame, FALSE, FALSE, 0);
   gtk_widget_show(syntax_frame);
   syntax_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(syntax_box), 10);
   gtk_container_add(GTK_CONTAINER(syntax_frame), syntax_box);   
   gtk_widget_show(syntax_box);
   util_box  = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(syntax_box), util_box, FALSE, TRUE, 0);         
   gtk_widget_show(util_box);
   syntax = make_button(_("Enable syntax highlighting ?"), util_box, &general_preferences.syntax);

   tabs_frame = gtk_frame_new(_("Indentation"));
   gtk_box_pack_start(GTK_BOX(filesettings_box), tabs_frame, TRUE, TRUE, 0);
   gtk_widget_show(tabs_frame);
   tabs_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(tabs_box), 5);
   gtk_container_add(GTK_CONTAINER(tabs_frame), tabs_box);   
   gtk_widget_show(tabs_box);

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(tabs_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   auto_indent = make_button(_("Auto Indent ?"), util_box, &general_preferences.auto_indent);

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(tabs_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   use_spaces = make_button(_("Use spaces instead of tabs ?"), util_box, &general_preferences.use_spaces);

   util_box = gtk_hbox_new(FALSE, 10);
   gtk_box_pack_start(GTK_BOX(tabs_box), util_box, TRUE, TRUE, 10);
   gtk_widget_show(util_box);
   util_label = gtk_label_new(_("Tab stop:"));
   gtk_box_pack_start(GTK_BOX(util_box), util_label, FALSE, FALSE, 0);   
   gtk_widget_show(util_label);

   spaces_spin = gtk_spin_button_new(GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 10, 1, 2, 0)), 1, 0);
   gtk_box_pack_start(GTK_BOX(util_box), spaces_spin, TRUE, TRUE, 0);   
   gtk_widget_show(spaces_spin);

   GtkWidget *hsep;
   hsep = gtk_hseparator_new();
   gtk_box_pack_start(GTK_BOX(main_box), hsep, FALSE, TRUE, 15);
   gtk_widget_show(hsep);

   buttons_box = gtk_hbox_new(TRUE, 10);
   gtk_box_pack_start(GTK_BOX(main_box), buttons_box, FALSE, FALSE, 0);
   gtk_widget_show(buttons_box);

   ok_button = gnome_stock_button(GNOME_STOCK_BUTTON_OK);
   gtk_box_pack_start(GTK_BOX(buttons_box), ok_button, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(save_settings), 0);
   gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(settings_window));
   gtk_widget_show(ok_button);

   apply_button = gnome_stock_button(GNOME_STOCK_BUTTON_APPLY);
   gtk_box_pack_start(GTK_BOX(buttons_box), apply_button, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(apply_button), "clicked", GTK_SIGNAL_FUNC(apply_settings), 0);
   gtk_widget_show(apply_button);

   defaults_button = gnome_stock_or_ordinary_button(_("Defaults"));
   gtk_box_pack_start(GTK_BOX(buttons_box), defaults_button, FALSE, TRUE, 0);   
   gtk_signal_connect(GTK_OBJECT(defaults_button), "clicked", GTK_SIGNAL_FUNC(get_defaults), 0);
   gtk_widget_show(defaults_button);

   undo_button = gnome_stock_or_ordinary_button(_("Undo"));
   gtk_box_pack_start(GTK_BOX(buttons_box), undo_button, FALSE, TRUE, 0);   
   gtk_signal_connect(GTK_OBJECT(undo_button), "clicked", GTK_SIGNAL_FUNC(get_backups), 0);
   gtk_widget_show(undo_button);

   cancel_button = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_box_pack_start(GTK_BOX(buttons_box), cancel_button, FALSE, TRUE, 0);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(redo_backups), 0);
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(settings_window));
   gtk_widget_show(cancel_button);

   gtk_widget_show(settings_window);
   put_preferences(&general_preferences);
}

void save_settings(GtkWidget *widget, gpointer data)
{
   get_preferences(&general_preferences);
   save_prefs();
   apply_settings_changes();
}

void apply_settings(GtkWidget *widget, gpointer data)
{
   get_preferences(&general_preferences);
   apply_settings_changes();
}

void get_defaults(GtkWidget *widget, gpointer data)
{
   put_preferences(&default_preferences);
}

void get_backups(GtkWidget *widget, gpointer data)
{
   put_preferences(&backup_preferences);
}

void redo_backups(GtkWidget *widget, gpointer data)
{
   copy_preferences(&backup_preferences, &general_preferences);
}

void get_preferences(Preferences *source)
{
   gchar *text;
   text = gnome_direntry_get_dir(GNOME_DIRENTRY(default_dir_entry));
   strncpy(source->default_dir, text, sizeof(source->default_dir));
   text = gnome_direntry_get_dir(GNOME_DIRENTRY(projects_dir_entry));
   strncpy(source->projects_dir, text, sizeof(source->projects_dir));
   source->history = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(hist_spin));
   source->undo_max = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(undo_spin));
   strncpy(source->name, gtk_entry_get_text(GTK_ENTRY(name_of_user)), sizeof(source->name));
   strncpy(source->email, gtk_entry_get_text(GTK_ENTRY(email_of_user)), sizeof(source->email));
   source->notebook_tab_position = get_which_radio_active(GTK_RADIO_BUTTON(notebook_pos_none)->group);
   strcpy(source->font_name, gnome_font_picker_get_font_name(GNOME_FONT_PICKER(font)));
   if(source->font && font_changed)
   { 
      gdk_font_unref(source->font);
      source->font = gdk_font_load(source->font_name);
      if(source->font) //dont fuck it up if there is an error.
         gdk_font_ref(source->font);
   }
   gnome_color_picker_get_i16(GNOME_COLOR_PICKER(fg), &source->fg.red, &source->fg.green, &source->fg.blue, NULL);
   gnome_color_picker_get_i16(GNOME_COLOR_PICKER(bg), &source->bg.red, &source->bg.green, &source->bg.blue, NULL);
   gnome_color_picker_get_i16(GNOME_COLOR_PICKER(s_fg), &source->s_fg.red, &source->s_fg.green, &source->s_fg.blue, NULL);
   gnome_color_picker_get_i16(GNOME_COLOR_PICKER(s_bg), &source->s_bg.red, &source->s_bg.green, &source->s_bg.blue, NULL);

   source->spaces = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spaces_spin));
}

void put_preferences(Preferences *source)
{
   gnome_direntry_set_dir(GNOME_DIRENTRY(default_dir_entry), source->default_dir);
   gnome_direntry_set_dir(GNOME_DIRENTRY(projects_dir_entry), source->projects_dir);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(save_session), source->save_session);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(open_session), source->open_session);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(hist_spin), (gfloat)source->history);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(undo_spin), (gfloat)source->undo_max);

   gtk_entry_set_text(GTK_ENTRY(name_of_user), source->name);
   gtk_entry_set_text(GTK_ENTRY(email_of_user), source->email);
   set_which_radio_active(GTK_RADIO_BUTTON(notebook_pos_none)->group, source->notebook_tab_position);

   gnome_font_picker_set_font_name(GNOME_FONT_PICKER(font), general_preferences.font_name);
   gnome_color_picker_set_i16(GNOME_COLOR_PICKER(fg), source->fg.red, source->fg.green, source->fg.blue, 0);
   gnome_color_picker_set_i16(GNOME_COLOR_PICKER(bg), source->bg.red, source->bg.green, source->bg.blue, 0);
   gnome_color_picker_set_i16(GNOME_COLOR_PICKER(s_fg), source->s_fg.red, source->s_fg.green, source->s_fg.blue, 0);
   gnome_color_picker_set_i16(GNOME_COLOR_PICKER(s_bg), source->s_bg.red, source->s_bg.green, source->s_bg.blue, 0);

   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(syntax), source->syntax);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(auto_indent), source->auto_indent);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(use_spaces), source->use_spaces);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(spaces_spin), (gfloat)source->spaces);
}

void copy_preferences(Preferences *source, Preferences *dest)
{
   strcpy(dest->default_dir, source->default_dir);
   strcpy(dest->projects_dir, source->projects_dir);
   dest->save_session = source->save_session;
   dest->open_session = source->open_session;
   dest->history = source->history;
   dest->undo_max = source->undo_max;

   strcpy(dest->name, source->name);
   strcpy(dest->email, source->email);
   dest->notebook_tab_position = source->notebook_tab_position;
   dest->fg.red = source->fg.red;
   dest->fg.green = source->fg.green;
   dest->fg.blue = source->fg.blue;
   dest->bg.red = source->bg.red;
   dest->bg.green = source->bg.green;
   dest->bg.blue = source->bg.blue;
   dest->s_fg.red = source->s_fg.red;
   dest->s_fg.green = source->s_fg.green;
   dest->s_fg.blue = source->s_fg.blue;
   dest->s_bg.red = source->s_bg.red;
   dest->s_bg.green = source->s_bg.green;
   dest->s_bg.blue = source->s_bg.blue;
   dest->font = source->font;
   strncpy(dest->font_name, source->font_name, sizeof(dest->font_name));

   dest->syntax = source->syntax;
   dest->auto_indent = source->auto_indent;
   dest->use_spaces = source->use_spaces;
   dest->spaces = source->spaces;
}

void set_font_changed(GnomeFontPicker *gfp, gchar *font_name, gpointer data)
{
   font_changed = TRUE;
}

void set_color_changed(GtkWidget *cp, guint r, guint g, guint b, guint a, gpointer data)
{
   if(cp == bg) bg_changed = TRUE;
   if(cp == fg) fg_changed = TRUE;
   if(cp == s_bg) s_bg_changed = TRUE;
   if(cp == s_fg) s_fg_changed = TRUE;
}

void toggle_button_switch(GtkWidget *widget, gint *value)
{
   *value ? *value=0 : *value=1;
}

GtkWidget *make_button(gchar *button_text, GtkWidget *which_box, gint *value)
{
   GtkWidget *button;
   button = gtk_check_button_new_with_label(button_text);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), *value);
   gtk_box_pack_start(GTK_BOX(which_box), button, FALSE, FALSE, 0);
   gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(toggle_button_switch), value);
   gtk_widget_show(button);
   return button;
}

void apply_settings_changes()
{
   GList *file = NULL;
   GdsFile *temp;
   GtkStyle *style;
   
   if(GTK_WIDGET(window)->window != NULL)
      gdk_window_set_cursor(GTK_WIDGET(window)->window, gdk_cursor_new(GDK_WATCH));

   if(general_preferences.notebook_tab_position >= 4)
   {
      gtk_notebook_set_show_tabs(GTK_NOTEBOOK(files_book), FALSE);
   }
   else
   {
      gtk_notebook_set_show_tabs(GTK_NOTEBOOK(files_book), TRUE);
      gtk_notebook_set_tab_pos(GTK_NOTEBOOK(files_book), (GtkPositionType) general_preferences.notebook_tab_position);
   }

   /* make changes to the global extext style */
   extext_style->text[GTK_STATE_NORMAL] = general_preferences.fg;
   extext_style->bg[GTK_STATE_NORMAL] = general_preferences.bg;
   extext_style->base[GTK_STATE_NORMAL] = general_preferences.bg;
   extext_style->text[GTK_STATE_SELECTED] = general_preferences.s_fg;
   extext_style->bg[GTK_STATE_SELECTED] = general_preferences.s_bg;

   if(font_changed)
   {
      if(extext_style->font)
         gdk_font_unref(extext_style->font); //one less ref for that.
      extext_style->font = general_preferences.font;
      gdk_font_ref(general_preferences.font);
      highlight_tables_font_change(general_preferences.font);
   }

   file = g_list_first(files_list);
   while(file)
   {
      temp = (GdsFile *)file->data;
      gtk_widget_set_style(temp->text, extext_style);
      if(font_changed)
         gds_editor_set_font(GDS_EDITOR(temp->text), general_preferences.font);
      if(bg_changed || font_changed)
         gds_editor_set_bgcolor(GDS_EDITOR(temp->text), &general_preferences.bg);
      if(fg_changed || font_changed)
         gds_editor_set_fgcolor(GDS_EDITOR(temp->text), &general_preferences.fg);
      if(s_fg_changed || s_bg_changed || font_changed)
         gds_editor_set_selection_colors(GDS_EDITOR(temp->text), &general_preferences.s_fg, &general_preferences.s_bg);
      if(font_changed && temp->tables)
      {
         gds_editor_install_table(GDS_EDITOR(temp->text), temp->tables->syntax);
         gds_editor_install_table(GDS_EDITOR(temp->text), temp->tables->pattern);
      }
      if(general_preferences.undo_max != backup_preferences.undo_max)
         gtk_extext_undo_set_max(GTK_EXTEXT(temp->text), general_preferences.undo_max);
      if(!temp->props.over_ride)
      {
         gds_editor_set_highlight(GDS_EDITOR(temp->text), general_preferences.syntax);      
         temp->props.auto_indent = general_preferences.auto_indent;
         temp->props.use_spaces = general_preferences.use_spaces;
         temp->props.spaces = general_preferences.spaces;
         GTK_EXTEXT(temp->text)->default_tab_width = general_preferences.spaces;
      }
      gtk_widget_queue_draw(temp->text);
      file = file->next;
   }
   setup_recent_files_list(general_preferences.history);
   if(GTK_WIDGET(window)->window != NULL)
      gdk_window_set_cursor(GTK_WIDGET(window)->window, gdk_cursor_new(GDK_LEFT_PTR));
}

gint get_which_radio_active(GSList *list)
{
   GSList *first;
   GSList *current;
   gint iterations = 0;
   GtkToggleButton *toggle;
   first = g_slist_copy(list);
   first = current = g_slist_reverse(first);
   while(current)
   {
      toggle = (GtkToggleButton *)current->data;
      if(toggle->active) break;
      iterations++;
      current = current->next;
   }
   g_slist_free(first);
   return(iterations);
}

void set_which_radio_active(GSList *list, gint which)
{
   GSList *first;
   GSList *current;
   GtkToggleButton *toggle;

   first = g_slist_copy(list);
   first = g_slist_reverse(first);
   toggle = (GtkToggleButton *)g_slist_nth_data(first, which);
   gtk_toggle_button_set_active(toggle, TRUE);
   g_slist_free(first);
}
