#ifndef SYNTAX_HIGHLIGHT_H
#define SYNTAX_HIGHLIGHT_H

void init_colors();
GdkColor *get_color(gchar *color);
void attach_highlight_tables(GdsFile *file_ptr);
gboolean detach_highlight_tables(GdsFile *file_ptr);
gboolean delete_highlight_tables(struct highlight_table *table);
struct highlight_table *find_highlight_tables(gchar *extension, gchar *cur_dir);
struct highlight_table *make_highlight_tables(gchar *fname);
GList * get_exts_list(gchar *filename);
gint get_language_settings(gchar *filename, Properties *props);
gchar *check_exts_list(gchar *ext, GList *exts);
void g_list_delete_all(GList *list);
gboolean get_str(gchar *source, gchar *dest, const gchar search[], gchar end, gint max_chars);
void highlight_tables_font_change(GdkFont *font);
gchar *get_file_var(gchar *filename, const gchar var[]);

struct highlight_table{
   gchar *filename;
   GList *extensions;
   GdsEditorHighlightTable *syntax;
   GdsEditorHighlightTable *pattern;
   Properties props;
   guint refcount; //refcount
};

extern GdkColor colors[16];
extern GList *highlight_tables;

#define BLACK 0
#define WHITE 1
#define RED   2
#define GREEN 3
#define BLUE  4
#define LT_RED  5
#define LT_GREEN 6
#define LT_BLUE 7
#define DK_RED 8
#define DK_GREEN 9
#define DK_BLUE 10
#define YELLOW 11
#define ORANGE 12
#endif