/* Gnome Developers Studio
*  
*  File Widget (MDI entry, text widget etc.)
*  Copyright 2000 by Chris Phelps
*  
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU Library General Public License for more details.
*
*  You should have received a copy of the GNU Library General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <gnome.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include "../declarations.h"

#ifndef GDS_FILE_H__
#define GDS_FILE_H__
#ifdef __cplusplus
extern "C" {
#endif

#define GDS_TYPE_FILE (gds_file_get_type())
#define GDS_FILE(obj) (GTK_CHECK_CAST((obj), GDS_TYPE_FILE, GdsFile))
#define GDS_FILE_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass), GDS_TYPE_FILE, GdsFileClass))
#define GDS_IS_FILE(obj) (GTK_CHECK_TYPE((obj), GDS_TYPE_FILE))
#define GDS_IS_FILE_CLASS(klass) (GTK_CHECK_CLASS_TYPE((klass), GDS_TYPE_FILE))

typedef struct _GdsFile GdsFile;
typedef struct _GdsFileClass GdsFileClass;

struct _GdsFile {
   GtkHBox box;
   GtkWidget *menu_item;
   GtkWidget *tear_away;
   GtkWidget *text;
   GtkWidget *vscroller;
   GtkWidget *paned;
   /* lot of crap, but it's needed */
   GtkWidget *notebook;
   GtkWidget *compile_list;
   GtkWidget *file_data;
   gchar *filename;
   gboolean read_only;
   struct highlight_table *tables;
   Properties props;
   gint compile_id;
   FILE *compile_file;
   gint debug_pid;
   gint exec_pid;
};

struct _GdsFileClass {
   GtkHBoxClass parent_class;
};

GtkType gds_file_get_type(void);

GtkWidget *gds_file_new(gchar *filename);
void gds_file_set_filename(GdsFile *gds_file, gchar *filename);
void gds_file_set_title(GdsFile *gds_file, gchar *title);
#ifdef __cplusplus /* cpp compatibility */
}
#endif
#endif